Easy fix?: No Copied to github as #: 20791
Description

As per title - QGIS app should make a backup copy of settings file(s) before writing out a new configuration.

Rationale - during a quite long georeferencing session with QGIS 2.9.0 (8b37ea?2), at some point something went south and all QGIS
settings were lost. First | observed missing WMS providers during the same work session, then, after restart of QGIS, | was greeted with a
pristine, first time run QGIS configuration. Costed me all WMS service providers with their configuration :( Afterwards | haven't been able
to reproduce configuration loss thus this is a wish on automatic backups not a bug report on configuration loss.

Related issues:
Related to QGIS Application - Feature request # 13496: Store connection setti... Open 2015-10-03

History

#1 - 2015-05-01 08:09 AM - Regis Haubourg

Hi, that's strange, here ini files are saved at every change. On what platform are you working? Did you configure a --configpath to move settings location?

#2 - 2015-09-20 02:03 PM - marisn -
Regis Haubourg wrote:
Hi, that's strange, here ini files are saved at every change. On what platform are you working? Did you configure a --configpath to move settings
location?
"ini files" - | assume you are on Windows. | use a ~AMD64 Gentoo Linux.
| haven't been looking into --configpath option thus can not comment if it helps to fix the issue.
| just (again!) lost all QGIS settings with all WMS services. Again georeferencing. Apparently | must back-up all settings files before using georeferencer.
8b2bbcd
#3 - 2015-09-21 01:52 AM - marisn -
| managed to track down the mechanism behind the loss of QGIS settings. The root cause is insecure writing of configuration files. Current logic is "open
old configuration file for writing; truncate it; write new configuration". If for some reason writing of new configuration fails, user is left with a truncated or
partially written configuration file. Georeferencer is not to blame here (gereferencing simply quite often might go south and fill the disk causing subsequent

writes to fail).

The correct sequence should be: write new configuration file; on success, rename to old file.

Such approach would allow QGIS configuration files to exist in two states - old or new but never in a corrupted one.
Of course - even better question is - should QGIS write to disk WMS settings each time some other of its application settings has been changed (i.e.

window position, recent used files etc.).

Analysis of this issue is based on file observations not on code analysis.

#4 - 2015-09-21 02:23 AM - Jiirgen Fischer

marisn - wrote:

Analysis of this issue is based on file observations not on code analysis.

We don't write the settings ourselves - that's Qt's QSettings.

#5 - 2015-10-03 02:06 AM - marisn -

| see :( As | again lost all QGIS settings + all my WMS settings, | find it a bit sad.

According to Qt bug tracker, QSettings storage is atomic starting from 5.4.0. One commenter also mentions a high speed penalty for writing large settings
files. https://bugreports.qgt.io/browse/QTBUG-21739

| created a separate wish for moving connection settings out of main QGIS settings: #13496

Jurgen, as | don't care so much for the rest of QGIS settings except connection ones, feel free to close this issue if implementing a workaround seems too

much work. | would prefer a solution proposed in #13496

#6 - 2017-05-01 12:47 AM - Giovanni Manghi

- Easy fix? set to No

#7 - 2017-09-22 10:07 AM - Jiirgen Fischer
- Category set to Unknown
